<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama satuan" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'unit', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Satuan
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="units" ref="unitTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama Satuan"
                width="150">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Simbol"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.symbol }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Pemilik"
                width="150"
                v-if="me.role.slug == 'root'">
                <template slot-scope="{row}">
                    <span v-if="row.owner != null">{{ row.owner.profile.fullname }}</span>
                    <span v-else>Default</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'unit', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'unit', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="unitForm" :model="unitForm" :rules="unitRules">
                <aside>
                    <el-alert type="info" description="Menampilkan tipe-tipe satuan produk yang anda pakai." :closable=false show-icon></el-alert>
                </aside>
                <el-row :gutter="20">
                    <el-col :lg="18" :md="24" :xs="24">
                        <el-form-item label="Nama Satuan" prop="name">
                            <el-input ref="name" name="name" v-model="unitForm.name" placeholder="Nama satuan" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="6" :md="24" :xs="24">
                        <el-form-item label="Simbol" prop="symbol">
                            <el-input ref="symbol" name="symbol" v-model="unitForm.symbol" placeholder="Simbol satuan" autocomplete="off" maxlength="10" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="unitForm.description" placeholder="Deskripsi satuan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'unit', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Unit',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            tableLoading: false,
            dialogLoading: false,
            filter: {
                keyword: ''
            },
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Satuan',
                create: 'Tambah Satuan'
            },
            unitForm: {
                id: null,
                name: '',
                symbol: '',
                description: '',
                archived: false
            },
            unitRules: {
                name: [{ 
                    required: true, message: 'Nama unit wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama unit maksimal 255 karakter', trigger: 'blur',
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                symbol: [{ 
                    required: true, message: 'Simbol unit wajib diisi', trigger: 'blur'
                }, {
                    max: 10, message: 'Panjang simbol maksimal 10 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z]{1,10})$/, message: 'Hanya huruf yang diperbolehkan', trigger: 'blur'
                }],
                description: [{ max: 255, message:'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'}]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('user', ['me']),
        ...mapGetters('unit', [
            'units',
            'pagination'
        ]),
    },
    created() {
        this.getUnits();
    },
    methods: {
        playSound,
        dateFormat,
        getUnits() {
            this.tableLoading = true;
            this.$store.dispatch('unit/getUnits', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('unit/getUnits', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['unitForm'].clearValidate();
            });
        },
        handleEdit(unit){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.unitForm.id = unit.id;
            this.unitForm.name = unit.name;
            this.unitForm.symbol = unit.symbol;
            this.unitForm.description = unit.description;  
            this.unitForm.archived = unit.archived;
            this.$nextTick(() => {
                this.$refs['unitForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.unitForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'unit/addUnit';
                        payload = {
                            name: this.unitForm.name,
                            symbol: this.unitForm.symbol,
                            description: this.unitForm.description
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'unit/editUnit';
                        payload = {
                            id: this.unitForm.id,
                            name: this.unitForm.name,
                            symbol: this.unitForm.symbol,
                            description: this.unitForm.description,
                            archived: this.unitForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(unit){
            this.$confirm('Anda mencoba untuk menghapus data unit, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('unit/deleteUnit', {
                    id: unit.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.unitForm = {
                id: null,
                name: '',
                symbol: '',
                description: ''
            }
        }
    }

}
</script>
